_global.PhotoAlbumPresenter = function() {
	//
	// Inheritance
	this.__proto__ = new MovieClip();
	//
	// Private Property
	var owner = this;
	var _totalPhoto = 0;
	var _currentLoadingPhoto = 0;
	var _rowNo = 10;
	var _puWidth = Stage.width/_rowNo;
	var _puHeight = 113;
	var _photo_xml = new PhotoXMLModel();
	//
	// Event Handler
	this.onPhotoListLoaded = function() {
		_totalPhoto = _photo_xml.getPhotoLength();
		_puHeight = Stage.height/Math.ceil((_totalPhoto/_rowNo));
		_currentLoadingPhoto = 0;
		var _photoPosA = genRandomNo(_totalPhoto);
		var pu;
		for (var i = 0; i<_totalPhoto; i++) {
			pu = attachMovie("photoUnit", "pu_"+i, 100+i);
			pu._x = _puWidth*(_photoPosA[i]%_rowNo)+_puWidth/2;
			pu._y = _puHeight*Math.floor(_photoPosA[i]/_rowNo)+_puHeight/2;
			pu.spath = _photo_xml.getSmallPhotoAt(i);
			pu.bpath = _photo_xml.getBigPhotoAt(i);
		}
		delete _photo_xml;
		delete _rowNo;
		delete _puWidth;
		delete _puHeight;
		loadPhoto(_currentLoadingPhoto);
	};
	this.onCurrentPhotoLoaded = function() {
		_currentLoadingPhoto++;
		if (_currentLoadingPhoto<_totalPhoto) {
			loadPhoto(_currentLoadingPhoto);
		} else {
			delete _currentLoadingPhoto;
			delete owner;
		}
	};
	this.onShowBigPhoto = function(pno) {
		for (var i = 0; i<_totalPhoto; i++) {
			if (i != pno) {
				eval("pu_"+i).onMoveSide();
			}
		}
	};
	this.onShowSmallPhoto = function(pno) {
		for (var i = 0; i<_totalPhoto; i++) {
			if (i != pno) {
				eval("pu_"+i).onMoveSmall();
			}
		}
	};
	//
	// Getter/Setter Method	
	function getRowNo(r) {
		return _rowNo;
	}
	function setRowNo(r) {
		_rowNo = r;
		_puWidth = Stage.width/_rowNo;
	}
	this.addProperty("rowNo", getRowNo, setRowNo);
	//
	// Private Method
	function genRandomNo(rno) {
		var tmpA = new Array();
		var newA = new Array();
		var i;
		for (var i = 0; i<rno; i++) {
			tmpA[i] = i;
		}
		for (var j = 0; j<rno; j++) {
			i = random(tmpA.length);
			newA[j] = tmpA[i];
			tmpA.splice(i, 1);
		}
		return newA;
	}
	function loadPhoto(i) {
		var pu = eval("pu_"+i);
		pu.id = i;
		pu.addListener(owner);
		pu.loadSmallPhoto();
	}
	//
	// Public Method
	this.loadXML = function(xn) {
		_photo_xml.load(xn);
		_photo_xml.addListener(this);
	};
};
