#initclip
_global.PhotoViewClass = function() {
	AsBroadcaster.initialize(this);
	this.bigLoaded = false;
	this.bigScale = 100;
	this.status = "small";
	// Small Photo Container
	this.createEmptyMovieClip("sp", 20);
	this.sp.createEmptyMovieClip("sp", 0);
	// Big Photo Container
	this.createEmptyMovieClip("bp", 21);
	// Loader Text
	this.createEmptyMovieClip("st", 22);
	this.st.createTextField("st", 21, 0, -6, 0, 0);
	this.st.st.embedFonts = true;
	this.st.st.selectable = false;
};
//
// Static Property
PhotoViewClass.highpic = "";
PhotoViewClass.bigX = Stage.width/2;
PhotoViewClass.bigY = Stage.height/2;
PhotoViewClass.smallScale = 100;
PhotoViewClass.sideScale = 70;
PhotoViewClass.loaderTextFormat = new TextFormat();
PhotoViewClass.loaderTextFormat.color = 0xcccccc;
PhotoViewClass.loaderTextFormat.font = "Arial";
PhotoViewClass.loaderTextFormat.bold = true;
//
// Inheritance
PhotoViewClass.prototype.__proto__ = MovieClip.prototype;
PhotoViewClass.prototype.__constructor__ = MovieClip;
// Getter/Setter Method
PhotoViewClass.prototype.getID = function(i) {
	return this._id;
};
PhotoViewClass.prototype.setID = function(i) {
	this._id = i;
};
PhotoViewClass.prototype.addProperty("id", PhotoViewClass.prototype.getID, PhotoViewClass.prototype.setID);
PhotoViewClass.prototype.getSPath = function(i) {
	return this._spath;
};
PhotoViewClass.prototype.setSPath = function(i) {
	this._spath = i;
};
PhotoViewClass.prototype.addProperty("spath", PhotoViewClass.prototype.getSPath, PhotoViewClass.prototype.setSPath);
PhotoViewClass.prototype.getBPath = function(i) {
	return this._bpath;
};
PhotoViewClass.prototype.setBPath = function(i) {
	this._bpath = i;
};
PhotoViewClass.prototype.addProperty("bpath", PhotoViewClass.prototype.getBPath, PhotoViewClass.prototype.setBPath);
//
// Event Handler
PhotoViewClass.prototype.onLoad = function() {
	this.smallX = this._x;
	this.smallY = this._y;
	var p = this.findSideXY();
	this.sideX = p.x;
	this.sideY = p.y;
	this.smallRotation = random(40)-random(40);
};
//
// Private Method
PhotoViewClass.prototype.findSideXY = function() {
	var fx;
	var fy;
	var ang = Math.atan2(this.smallY-PhotoViewClass.bigY, this.smallX-PhotoViewClass.bigX);
	fx = Math.cos(ang)*PhotoViewClass.bigX+PhotoViewClass.bigX;
	fy = Math.sin(ang)*PhotoViewClass.bigY+PhotoViewClass.bigY;
	return {x:fx, y:fy};
};
PhotoViewClass.prototype.loadBigPhoto = function() {
	var owner = this;
	this.bp.loadMovie(this._bpath);
	// Loader Text
	this.st.onEnterFrame = function() {
		owner.preloader(owner.bp);
	};
};
PhotoViewClass.prototype.preloader = function(mc) {
	// scope in this MC
	var lb = mc.getBytesLoaded();
	var tb = mc.getBytesTotal();
	mc._visible = false;
	var percent = Math.round(lb/tb*100);
	this.st.st.text = percent+"%";
	this.st.st.autoSize = "center";
	this.st.st.setTextFormat(PhotoViewClass.loaderTextFormat);
	if (percent == 100 and lb>1000 and tb>1000 and mc._width>0 and mc._height>0) {
		this.st.st.text = "";
		mc._alpha = 0;
		mc._x -= mc._width/2;
		mc._y -= mc._height/2;
		if (mc._name == "sp") {
			this._rotation = this.smallRotation;
			this.smallWidth = mc._width;
			this.broadcastMessage("onCurrentPhotoLoaded");
			this.onRelease = this.clickMe;
			mc._visible = true;
			mc.onEnterFrame = this.fadeIn;
		} else {
			this.bigScale = Math.round(mc._width/this.smallWidth*100);
			delete this.smallWidth;
			this.bigLoaded = true;
			if (this.status == "big") {
				mc._visible = true;
				mc.onEnterFrame = this.fadeIn;
			} else {
				mc._alpha = 100;
			}
		}
		delete this.st.onEnterFrame;
	}
};
PhotoViewClass.prototype.fadeIn = function() {
	this._alpha += 10;
	if (this._alpha>=100) {
		this._alpha = 100;
		delete this.onEnterFrame;
	}
};
PhotoViewClass.prototype.fadeOut = function() {
	this._alpha -= 10;
	if (this._alpha<=0) {
		this._alpha = 0;
		delete this.onEnterFrame;
	}
};
PhotoViewClass.prototype.clickMe = function() {
	if (this.status == "small") {
		// Self Big
		if (this.onEnterFrame == undefined) {
			this.onEnterFrame = this.moveToBig;
		} else {
			return;
		}
		this.status = "big";
		this.swapDepths(10000);
		if (!this.bigLoaded) {
			this._rotation = 0;
			this.sp.onEnterFrame = this.fadeOut;
			this.loadBigPhoto();
		}
		PhotoViewClass.highpic = this._name;
		// Tell other pic go side through controller
		this.broadcastMessage("onShowBigPhoto", this._id);
		_quality = "low";
	} else {
		// Self Small
		if (this.onEnterFrame == undefined) {
			this.onEnterFrame = this.moveToSmall;
		} else {
			return;
		}
		this.status = "small";
		this.bp._visible = false;
		// Because bp 1st load made sp fadeOut
		this.sp._alpha = 100;
		this.sp._visible = true;
		// Tell other pic go small through controller
		this.broadcastMessage("onShowSmallPhoto", this._id);
		_quality = "low";
	}
};
PhotoViewClass.prototype.onMoveSmall = function() {
	this.status = "small";
	delete this.sp.onEnterFrame;
	this.sp._alpha = 100;
	this.sp._visible = true;
	this.bp._visible = false;
	this.onEnterFrame = this.moveToSmall;
};
PhotoViewClass.prototype.onMoveSide = function() {
	this.status = "small";
	delete this.sp.onEnterFrame;
	this.sp._alpha = 100;
	this.sp._visible = true;
	this.bp._visible = false;
	this.onEnterFrame = this.moveToSide;
};
PhotoViewClass.prototype.moveToBig = function() {
	if (this._x>PhotoViewClass.bigX-5 and this._x<PhotoViewClass.bigX+5 and this._y>PhotoViewClass.bigY-5 and this._y<PhotoViewClass.bigY+5 and this.sp._xscale>this.bigScale-5 and this.sp._xscale<this.bigScale+5 and this.sp._yscale>this.bigScale-5 and this._yscale<this.bigScale+5) {
		this._x = PhotoViewClass.bigX;
		this._y = PhotoViewClass.bigY;
		this.sp._xscale = this.sp._yscale=this.bigScale;
		this.sp._visible = false;
		this.bp._visible = true;
		delete this.onEnterFrame;
		_quality = "high";
	} else {
		this._x += (PhotoViewClass.bigX-this._x)/4;
		this._y += (PhotoViewClass.bigY-this._y)/4;
		this.sp._xscale += (this.bigScale-this.sp._xscale)/2;
		this.sp._yscale += (this.bigScale-this.sp._yscale)/2;
		this._rotation += (0-this._rotation)/2;
	}
};
PhotoViewClass.prototype.moveToSmall = function() {
	if (this._x>this.smallX-5 and this._x<this.smallX+5 and this._y>this.smallY-5 and this._y<this.smallY+5 and this.sp._xscale>PhotoViewClass.smallScale-5 and this.sp._xscale<PhotoViewClass.smallScale+5 and this.sp._yscale>PhotoViewClass.smallScale-5 and this.sp._yscale<PhotoViewClass.smallScale+5) {
		this._x = this.smallX;
		this._y = this.smallY;
		this.sp._xscale = this.sp._yscale=PhotoViewClass.smallScale;
		if (this._name == PhotoViewClass.highpic) {
			PhotoViewClass.highpic = "";
			_quality = "high";
		}
		delete this.onEnterFrame;
	} else {
		this._x += (this.smallX-this._x)/5;
		this._y += (this.smallY-this._y)/5;
		this.sp._xscale += (PhotoViewClass.smallScale-this.sp._xscale)/4;
		this.sp._yscale += (PhotoViewClass.smallScale-this.sp._yscale)/4;
		this._rotation += (this.smallRotation-this._rotation)/4;
	}
};
PhotoViewClass.prototype.moveToSide = function() {
	if (this._x>this.sideX-5 and this._x<this.sideX+5 and this._y>this.sideY-5 and this._y<this.sideY+5 and this.sp._xscale>PhotoViewClass.sideScale-5 and this.sp._xscale<PhotoViewClass.sideScale+5 and this.sp._yscale>PhotoViewClass.sideScale-5 and this.sp._yscale<PhotoViewClass.sideScale+5) {
		this._x = this.sideX;
		this._y = this.sideY;
		this.sp._xscale = this.sp._yscale=PhotoViewClass.sideScale;
		delete this.onEnterFrame;
	} else {
		this._x += (this.sideX-this._x)/4;
		this._y += (this.sideY-this._y)/4;
		this.sp._xscale += (PhotoViewClass.sideScale-this.sp._xscale)/4;
		this.sp._yscale += (PhotoViewClass.sideScale-this.sp._yscale)/4;
		this._rotation += (this.smallRotation-this._rotation)/4;
	}
};
//
// Public Method
PhotoViewClass.prototype.loadSmallPhoto = function() {
	var owner = this;
	this.sp.sp.loadMovie(this._spath);
	this.st.onEnterFrame = function() {
		// scope is inside this.st
		owner.preloader(owner.sp.sp);
	};
};
Object.registerClass("photoUnit", PhotoViewClass);
#endinitclip
